<?php
/**
 * This file was created by PHP MySQL development accelerator
 * http://en.cze.cz/PHP-MySQL
 * Folder with SQL files: <SQL_SOURCE_DIRECTORY />
 * Time of creation: <CREATION_TIME />
 * 
 * @author Jaromir Sivic
 */
class /*<CLASS_PREFIX />*/Database
{
    private $databaseName; //name of the database
    /**
     * Handle of database opened by mysql_pconnect
     * @var int
     */
    public $dbHandle;
    /**
     * Last time called sql query.
     * @var string
     */
    public $latestSqlQuery = "";
    /**
     * Log for errors
     * @var string
     */
    private $errorLog = "";
    /**
     * If hardTestingEnabled is true then testLatestSqlQueryResultForErrors will use die method
     * @var boolean
     */
    public $hardTestingEnabled = true;
    /**
     * SQL result returned by function mysql_query.
     * @var int
     */
    public $latestSqlQueryResult = NULL;
    /**
     * Property is true if transactionStart was called
     * and no pair transactionCommit or Rollback was called
     * @var boolean
     */
    private $insideTransaction = false;
    /**
     * Contain all SQL Commands
     * @var <CLASS_PREFIX />_NS_SQL
     */
    public $sql;
    /**
     * Create new connection to database
     * @param string $databaseName name of the database
     * @param string $userName user who has privilages to use database "$databaseName"
     * @param string $password password for user "$userName"
     * @param string $hostName URL or IP address of database server
     */
    public function __construct($aDatabaseName = "/*<DEFAULT_DATABASE_NAME />*/",$aUserName = "/*<DEFAULT_USER_NAME />*/",$aPassword = "/*<DEFAULT_PASSWORD />*/",$aDatabaseServer="/*<DEFAULT_DATABASE_SERVER />*/")
    {
        $this->dbHandle = mysql_pconnect($aDatabaseServer, $aUserName, $aPassword) or trigger_error(mysql_error(),E_USER_ERROR);
        $this->databaseName = $aDatabaseName;
        $this->mysqlSelectDB();
        $this->sql = new /*<CLASS_PREFIX />*/_NS_SQL($this);
        register_shutdown_function(array('/*<CLASS_PREFIX />*/Database','onShutdown'),&$this);
    }
    /**
     * Select this database
     */
    public function mysqlSelectDB()
    {
        if(!mysql_select_db($this->databaseName,$this->dbHandle))
        {
            die("Cannot select database \"$this->databaseName\".");
        }
    }
    /**
     * Return count of rows affected by latest sql query
     * @return int
     */
    public function getCountOfAffectedRows()
    {
        if(is_null($this->latestSqlQueryResult)) return 0;
        return mysql_affected_rows($this->latestSqlQueryResult);
    }
    /**
     * Rollback all opened transactions
     * @param mixed $db
     */
    public static function onShutdown($db)
    {
        if(!is_null($db))
        {
            if($db->isInsideTransaction())
            {
                $db->transactionRollback();
            }
        }
    }
    /**
     * By default strict testing is enabled - that means if any
     * error occurs during PHP <=> MySql communication the script will die.
     * 
     * @param boolean $enabled 
     */
    public function setStrictTesting($enabled)
    {
       $this->hardTestingEnabled = $enabled;
    }
    /**
     * Test if latest sql query was executed successfully. If there was no error
     * it will return an empty string.<br />
     * Warning:<br />
     * If strict testing is true and there was an error the script will
     * automatically die.
     *
     * @see setStrictTesting
     * @return string
     */
    public function getErrors()
    {
        $errno = mysql_errno($this->dbHandle);
        if($errno==0) return "";
        try
        {
            $errorText = mysql_error($this->dbHandle);
            throw new Exception("ERROR CODE ".$errno." in SQL \"".$this->getLatestSqlQueryText().
                        "\".<br /><br />MySql responded: <br /><br />".$errorText.
                        "<br /><br />");
        }
        catch(Exception $err)
        {
            $this->errorLog .= $err->getMessage()."Stack:<br />" .
                               str_replace("\n","<br />\n",$err->getTraceAsString())."<br /><br />";
            if($this->hardTestingEnabled)
            {
                die($this->errorLog);
            }
        }
        return $errorLog;
    }
    /**
     * Return last time executed sql query.
     * @return string
     */
    public function getLatestSqlQueryText()
    {
        return $this->latestSqlQuery;
    }
    /**
     * Return latest SQL query result returned by mysql_query;
     * @return int 
     */
    public function getLatestSqlQueryResult()
    {
        return $this->latestSqlQueryResult;
    }
    /**
     * Start transaction.
     * @param boolean $enableConsistentSnapshot enables consistent snapshot.
     * This feature is available only for Inno DB.
     * @see transactionCommit
     */
    public function transactionStart($enableConsistentSnapshot=false)
    {
        $this->mysqlSelectDB();
        mysql_query('SET autocommit=0',$this->dbHandle);
        $postfix = '';
        if($enableConsistentSnapshot){$postfix = ' WITH CONSISTENT SNAPSHOT';}
        $this->insideTransaction = true;
        mysql_query('START TRANSACTION'.$postfix,$this->dbHandle);
    }
    /**
     * Commit current transaction
     * @see transactionStart
     */
    public function transactionCommit()
    {
        $this->mysqlSelectDB();
        mysql_query('COMMIT',$this->db);
        $this->insideTransaction = false;
    }
    /**
     * Rollback current transaction
     * @see transactionStart
     */
    public function transactionRollback()
    {
        $this->mysqlSelectDB();
        mysql_query('ROLLBACK',$this->db);
        $this->insideTransaction = false;
    }
    /**
     * Return true if transactionStart was called
     * without any pair transactionCommit or transactionRollback
     * @return boolean
     */
    public function isInsideTransaction()
    {
        return $this->insideTransaction;
    }
}


class /*<CLASS_PREFIX />*/DataSet
{
    private $sqlResult;
    /**
     * Pointer to the database
     * @var Database
     */
    private $db;
    /**
     * Detect if dataset is closed
     * @var boolean
     */
    private $closed = false;
    /**
     * sql query which was executed before dataset was created
     * @var string
     */
    private $sqlQuery = "";
    /**
     * Create new DataSet for sql query
     * @param mixed $aSqlResult
     */
    public function __construct($aSqlResult, &$aParentDatabase)
    {
        $this->sqlResult = $aSqlResult;
        $this->db = &$aParentDatabase;
        $this->sqlQuery = $this->db->latestSqlQuery;
    }
    /**
     * Destroy dataset
     */
    public function __destruct()
    {
        $this->close();
    }
    /**
     * Return link identifier returned by mysql_query
     * @return mixed
     */
    public function getMySqlQueeryLinkIdentifier() {
        return $this->sqlResult;
    }
    /**
     * Return number of rows stored in DataSet
     * @return int
     */
    public function getRowsCount() {
        try {
            if (!$this->testClosedWithAlert()) {
                return mysql_num_rows($this->sqlResult);
            }
        } catch (Exception $err) {
            $this->showError("Dataset->getRowsCount()", $err);
        }
    }
    /**
     * Return columns count.
     * @return int
     */
    public function getColumnsCount() {
        try {
            if (!$this->testClosedWithAlert()) {
                return mysql_num_fields($this->sqlResult);
            }
            return 0;
        } catch (Exception $err) {
            $this->showError("Dataset->getColumnsCount()", $err);
        }
    }
    /**
     * Return name of the column with columnIndex
     * @param int $columnIndex
     * @return string
     */
    public function getColumnName($columnIndex) {
        try {
            if (!$this->testClosedWithAlert()) {
                if (!($columnIndex < mysql_num_fields($this->sqlResult))) {
                    throw new Exception("Parameter columnIndex is higher than columnsCount");
                }
                return mysql_field_name($this->sqlResult, $columnIndex);
            }
        } catch (Exception $err) {
            $this->showError("Dataset->getColumnName()", $err);
        }
    }
    /**
     * Return SQL query (SELECT) which has created current dataset.
     * @return string
     */
    public function getSqlQueryText() {
        return $this->sqlQuery;
    }
    /**
     * Show error message
     * @param string $functionName
     * @param Error $err 
     */
    private function showError($functionName, $err) {
        die($err->getMessage()."<br /><br />".
            "Error in " . $functionName . ". Dataset was created by query:<br />" .
            $this->sqlQuery . "<br /><br />" . 
            str_replace("\n", "\n<br />", $err->getTraceAsString()));
    }
    /**
     * Test if dataset was closed
     * @return boolean
     */
    private function testClosedWithAlert() {
        if ($this->closed) {
            Throw new Exception("Dataset was already closed");
            return true;
        }
        return false;
    }
    /**
     * Return true if dataset was properly closed.
     * @return boolean
     */
    public function isClosed() {
        return $this->closed;
    }
    /**
     * Return one row from data retreived from database
     *
     * @example
     * if($dataset->getRowsCount()>0)<br/>
     * {<br/>
     *   $row = $dataset->getOneRow(0);<br/>
     *   echo $row["user_name"];<br/>
     * }<br/>
     *
     * @param int $rowIndex index of the row
     * @return Array
     */
    public function getRow($rowIndex) {
        try {
            if (!$this->testClosedWithAlert()) {
                if (!($rowIndex < mysql_num_rows($this->sqlResult))) {
                    throw new Exception("Parameter rowIndex is higher than rowsCount.");
                }
                mysql_data_seek($this->sqlResult, $rowIndex);
                return mysql_fetch_assoc($this->sqlResult);
            }
        } catch (Exception $err) {
            $this->showError("Dataset->getRow()", $err);
        }
    }
    /**
     * Return row of select as object
     * @param int $rowIndex
     * @return mixed
     */
    public function getRowAsObject($rowIndex) {
        try {
            if (!$this->testClosedWithAlert()) {
                if (!($rowIndex < mysql_num_rows($this->sqlResult))) {
                    throw new Exception("Parameter rowIndex is higher than rowsCount.");
                }
                mysql_data_seek($this->sqlResult, $rowIndex);
                return mysql_fetch_object($this->sqlResult);
            }
        } catch (Exception $err) {
            $this->showError("Dataset->getRowAsObject()", $err);
        }
    }
    /**
     * Return array of rows
     *
     * @see getRow
     *
     * @param int $rowIndex index of first line (record returned by sql SELECT command)
     * @param int $length how many rows (records returned by sql SELECT command) return.
     * Default length 0xFFFFFFFF
     * @return ArrayOfArray
     */
    public function getRows($rowIndex=0, $length=0xFFFFFF) {
        try {
            if (!$this->testClosedWithAlert()) {
                $rowsCount = $this->getRowsCount();
                //repair parameters
                $rowIndex = max(0, $rowIndex);
                if (!($rowIndex < $rowsCount)) {
                    throw new Exception("Parameter rowIndex is higher than rowsCount.");
                }
                $stop = min($rowsCount, $rowIndex + $length);
                //get all rows
                mysql_data_seek($this->sqlResult, $rowIndex);
                for ($a = 0; $a < max(0, $stop - $rowIndex); $a++) {
                    $result[$a] = mysql_fetch_assoc($this->sqlResult);
                }
                //return result
                return $result;
            }
        } catch (Exception $err) {
            $this->showError("Dataset->getRows()", $err);
        }
    }
    /**
     * Return cell data. Cell position is described by
     * rowIndex and columnName.
     * @param int $rowIndex index of the row where the cell is located
     * @param string $columnName name of the column where the cell is located
     * @return mixed
     */
    public function getCellByName($rowIndex, $columnName) {
        try {
            if (!$this->testClosedWithAlert()) {
                if (!($rowIndex < mysql_num_rows($this->sqlResult))) {
                    throw new Exception("Parameter rowIndex is higher than rowsCount.");
                }
                mysql_data_seek($this->sqlResult, $rowIndex);
                $actual_row = mysql_fetch_assoc($this->sqlResult);
                if (!(key_exists($columnName,$actual_row))) {
                    Throw new Exception("Column \"" . $columnName . "\" does not exist.");
                }
                return $actual_row[$columnName];
            }
        } catch (Exception $err) {
            $this->showError("Dataset->getCellByName()", $err);
        }
    }
    /**
     * Return cell data. Cell position is described by
     * rowIndex and columnName both integers (zero based).
     * @param int $rowIndex
     * @param int $columnIndex
     * @return mixed
     */
    public function getCellByIndex($rowIndex, $columnIndex) {
        try {
            if (!$this->testClosedWithAlert()) {
                if (!($rowIndex < mysql_num_rows($this->sqlResult))) {
                    throw new Exception("Parameter rowIndex is higher than rowsCount.");
                }
                mysql_data_seek($this->sqlResult, $rowIndex);
                $actual_row = mysql_fetch_assoc($this->sqlResult);
                $keys = array_keys($actual_row);
                if (!($columnIndex < sizeof($keys))) {
                    throw new Exception("Parameter columnIndex is higher than columnsCount.");
                }
                return $keys[$columnIndex];
            }
        } catch (Exception $err) {
            $this->showError("Dataset->getCellByIndex()", $err);
        }
    }
    /**
     * Return data from cell $rowIndex, $columnIndexOrName
     * columnIndexOrName can be integer or string.
     * @param int $rowIndex
     * @param mixed $columnIndexOrName
     * @return mixed
     */
    public function getCell($rowIndex, $columnIndexOrName)
    {
        if(is_int($columnIndexOrName))
        {
            return $this->getCellByIndex($rowIndex,$columnIndexOrName);
        }
        else
        {
            return $this->getCellByName($rowIndex,$columnIndexOrName);
        }
    }
    /**
     * Close dataset and free mysql result.
     */
    public function close() {
        try {
            if(!($this->closed))
            {
                @mysql_free_result($sql);
                $this->closed = true;
            }
        } catch (Exception $err) {
            $this->showError("Dataset->close()", $err);
        }
    }
}
/*<SQLDATA />*/
?>